#ifndef main_H
#define main_H

//### Defines ###
#define LED_off PORTC &= ~(1<<PC4)
#define LED_on PORTC |= (1<<PC4)
#define LED_toggle PINC|=(1<<PC4)

#define FAN_off PORTC &= ~(1<<PC5)
#define FAN_on PORTC |=  (1<<PC5)

#define AHIGH_on PORTD |= (1<<PD3)
#define AHIGH_off PORTD &= ~(1<<PD3)
#define ALOW_on  PORTD &= ~(1<<PD2)
#define ALOW_off  PORTD |= (1<<PD2)

#define BHIGH_on PORTD |= (1<<PD5)
#define BHIGH_off PORTD &= ~(1<<PD5)
#define BLOW_on  PORTD &= ~(1<<PD4)
#define BLOW_off  PORTD |= (1<<PD4)

#define CHIGH_on PORTD |= (1<<PD7)
#define CHIGH_off PORTD &= ~(1<<PD7)
#define CLOW_on  PORTD &= ~(1<<PD6)
#define CLOW_off  PORTD |= (1<<PD6)
//###########

//### Function Prototypes ####
void port_init(void); //Initializes the basic AVR-Port-Configurations
void peripheral_init(void); //Initializes the peripheral stuff in the AVR (except timers)
void timer_init(void); //initializes the timers and thus starts the saw
void scram(uint8_t param); //scrams the saw and brings it to a complete stop
//####################

//### Global Variables that are used in other files: ###
extern volatile char *uartpoint; //needed for the uart-interrupt
extern volatile uint8_t uartstat; //status of the uart-transmission
extern volatile uint8_t adccnt; //needed for the ADC (counts the measurements made)
extern volatile uint16_t adcvalue; //needed for the ADC (sums up the measurements to build an average)
//##################################
#endif
