/* 
These are the UART-Routines for the BASTLI Circular Saw. 
Mario Mauerer 2011
*/

#include <avr/io.h>   
#include <stdlib.h>
#include "uart_saw.h"
#include "main_saw.h"

//###### Send a String #######
//This routine sends a string via the Uart. 
//It handles the uart interrupt-based. 
//Max length of string: 47 chars!
void uart_stringsend(char *text)
{
	while(uartstat != 0) //wait for current transmission to finish. (there is no FIFO...)
	{
	}
	
	char uartarray[50]; //this array holds the modified string.
	uint8_t cnt = 0;
	
	while(*text) //transfer the contents of  text to uartarray ==> make a copy of the original string.
	{
		uartarray[cnt] = *text;
		cnt++; //next array indices
		text++; //next char in the string
	}
	uartarray[cnt] = 0x0D; //now, add a line feed and carriage return to the original string
	cnt++; 
	uartarray[cnt] = 0x0A;
	cnt++;
	uartarray[cnt] = 0x00; //string terminator
	
	uartpoint = uartarray; //transmit this array
	
	while (!(UCSR0A & (1<<UDRE0))) // Wait until Buffer is empty - ready to send.
	{
	}
	UDR0 = *uartpoint; //send first byte
	uartpoint++; //next char
	uartstat = 1; //transmission is in progress
	UCSR0B |= (1<<TXCIE0);//enable TX-complete-Interrupt

}
//#####################


//###### Send a Int16 #######
//This sends an integer to the terminal, it uses uart_stringsend.
void uart_intsend(int16_t number)
{
	char numberarray[7] ; //this holds the string of the number
	
	itoa(number, numberarray, 10); //convert the number to a string
	
	uart_stringsend(numberarray); //send the string
	
}
//#####################